package com.justtide.service.dev.aidl;

import com.justtide.service.dev.aidl.card.RFCCardReaderProvider;
import com.justtide.service.dev.aidl.card.SmartCardReaderProvider;
import com.justtide.service.dev.aidl.card.MSRCardReaderProvider;
import com.justtide.service.dev.aidl.card.M1CardReaderProvider;
import com.justtide.service.dev.aidl.card.PSAMCardReaderProvider;
import com.justtide.service.dev.aidl.card.CardReaderProvider;
import com.justtide.service.dev.aidl.pinpad.PinpadProvider;
import com.justtide.service.dev.aidl.emv.EmvProvider;
import com.justtide.service.dev.aidl.printer.PrinterProvider;
import com.justtide.service.dev.aidl.basic.BasicInfoProvider;
import com.justtide.service.dev.aidl.system.SystemProvider;
import com.justtide.service.dev.aidl.signature.SignatureProvider;
import com.justtide.service.dev.aidl.scan.ScanProvider;
import com.justtide.service.dev.aidl.util.UtilsProvider;

interface DeviceProvider {
    //Get contacless card module 
	RFCCardReaderProvider getRFCCardReaderProvider();
	
	//Get smart card module
	SmartCardReaderProvider getSmartCardReaderProvider();
	
	//Get magnetic module
	MSRCardReaderProvider getMSRCardReaderProvider();
	
	//Get CardReader module
	CardReaderProvider getCardReaderProvider();
    ScanProvider getScanProvider();
	
	PinpadProvider  getPinpadProvider();
	EmvProvider getEmvProvider();
	PrinterProvider getPrinterProvider();
	
	BasicInfoProvider getBasicInfoProvider();
	SystemProvider getSystemProvider();
	SignatureProvider getSignatureProvider();
	
	PSAMCardReaderProvider getPSAMCardReaderProvider();
	UtilsProvider getUtilsProvider();
	
	
	 
	//EthernetProvider getEthernetProvider();	//获取以太网模块
	 
    // M1CardProvider getM1CardProvider();//获取M1卡模块
 
}