package com.justtide.service.dev.aidl.card;

import com.just.api.PosDevice;

public class CardReaderConstant {
	/***************************************SmartCardRead *****************************************/

	/**********************************Error code defined******************************************/
	public static final int ICCARD_ERR_BASE = -1000;
	public static final int ICCARD_ERR_SUCCESS            = 0;
	public static final int ICCARD_ERR_CONNECT_FAILED     = ICCARD_ERR_BASE - 1;
	public static final int ICCARD_ERR_CMD_TIMEOUT        = ICCARD_ERR_BASE - 2; 
	public static final int ICCARD_ERR_VCCERR             = ICCARD_ERR_BASE - 3;
	public static final int ICCARD_ERR_SLOTERR            = ICCARD_ERR_BASE - 4;
	public static final int ICCARD_ERR_APDU               = ICCARD_ERR_BASE - 5;
	public static final int ICCARD_ERR_PARERR             = ICCARD_ERR_BASE - 6;
	public static final int ICCARD_ERR_SEARCH_CARD_TIMEOUT  = ICCARD_ERR_BASE - 7;
	
	/***********************SmartCardRead slot *************************************************************/
	public static final byte ICCARD_SLOT = 1;	
	
	/***********************SmartCardRead Voltage *********************************************************/
	public static final byte ICCARD_VCC_5V = 1;
	public static final byte ICCARD_VCC_3V = 2;
	public static final byte ICCARD_VCC_1V8 = 3;
	
	/***********************SmartCardRead model*********************************************************/
	public static final boolean ICCARD_EMV_MOD = true;
	public static final boolean ICCARD_ISO_MOD = false;
	
	/***********************SmartCardRead default value*********************************************************/
	public static final int DEFAULT_ICCARD_CHECK_TIMEOUT = 60000;
	public static final int DEFAULT_ICCARD_SLOT = ICCARD_SLOT;
	public static final int DEFAULT_ICCARD_VCC_MOD = ICCARD_VCC_5V;
	public static final boolean DEFAULT_ICCARD_EMV_MOD = ICCARD_EMV_MOD;
	
	
	/***********************SmartCardRead State *********************************************************/
	
	public static final int ICCARD_STATE_CLOSED      = 0;   //device close
	public static final int ICCARD_STATE_OPEN        = 1;   //device open
	public static final int ICCARD_STATE_CHECK_CARD  = 2;   //already check the card
	public static final int ICCARD_STATE_DEATIVATION = 3;   //already check the card,but card not power on
	public static final int ICCARD_STATE_READY       = 4;   //all is ok, could send the APDU command
	
	/***************************************RFCCardRead *****************************************/
	
	/***********************RFCCardRead 错误码定义Error code defined *********************************************************/
	public static final int RFCCARD_ERR_BASE = -2000;
	public static final int RFCCARD_ERR_SUCCESS            = 0;
	public static final int RFCCARD_ERR_CONNECT_FAILED     = RFCCARD_ERR_BASE - 1;
	public static final int RFCCARD_ERR_CMD_TIMEOUT        = RFCCARD_ERR_BASE - 2; 
	public static final int RFCCARD_ERR_SLOTERR            = RFCCARD_ERR_BASE - 3;
	public static final int RFCCARD_ERR_APDU               = RFCCARD_ERR_BASE - 4;
	public static final int RFCCARD_ERR_USER_CANCEL        = RFCCARD_ERR_BASE - 5;
	public static final int RFCCARD_ERR_PARERR             = RFCCARD_ERR_BASE - 6;
	public static final int RFCCARD_ERR_CARD_TYPE_ERR      = RFCCARD_ERR_BASE - 7;
	public static final int RFCCARD_ERR_INVALID_CARD       = RFCCARD_ERR_BASE - 8;
	public static final int RFCCARD_ERR_UNREMOVE_ERR       = RFCCARD_ERR_BASE - 9;
	public static final int RFCCARD_ERR_SEARCH_CARD_TIMEOUT= RFCCARD_ERR_BASE - 10;
	
	/***********************RFCCardRead slot定义*************************************************************/
	public static final byte RFCCARD_SLOT = 1;	 
	
	/***********************RFCCardRead 卡检测类型*********************************************************/
	public static final byte RFCCARD_SEARCH_TYPE_ALL        = 0x00;
	public static final byte RFCCARD_SEARCH_TYPE_A          = 0x01;
	public static final byte RFCCARD_SEARCH_TYPE_B          = 0x02;
	
	
	/***********************RFCCardRead State define*********************************************************/
	public static final int RFCARD_STATE_CLOSED   = 0;   //读卡器关闭
	public static final int RFCARD_STATE_OPEN     = 1;   //读卡器打开
	public static final int RFCARD_STATE_POLLING  = 2;   //正在检测卡
	public static final int RFCARD_STATE_READY    = 3;   //检测到卡
	public static final int RFCARD_STATE_REMOVING = 4;    //卡片移走
	
	/***********************RFCCardRead 检测模式*********************************************************/
	public static final byte RFCCARD_POLL_MOD_NORMAL = 0x00;
	public static final byte RFCCARD_POLL_MOD_OTHER0 = 0x01;
	
	/***********************RFCCardRead 参数默认值定义*********************************************************/
	public static final byte DEFAULT_RFCCARD_SLOT = RFCCARD_SLOT;
	public static final int DEFAULT_RFCCARD_CHECK_TIMEOUT = 60000;
	
	
	public static final  int RFCCARD_USER_CANCEL = -2005; 
	public static final  int RFCCARD_CMD_TIMEOUT = -2002;
	
	public static final byte M1_KEYTYPE_A = 'A';
	public static final byte M1_KEYTYPE_B = 'B';
	
	public static final int M1_OP_BACKUP = 0;   //backup
	public static final int M1_OP_INCREMENT = 1; // increment
	public static final int M1_OP_DECREMENT = 2; // decrement
	
	/***********************MSRCardRead 错误码定义Error code defined *********************************************************/
	public static final int MSRCARD_ERR_BASE = -3000;
	public static final int MSRCARD_ERR_SUCCESS            = 0;
	public static final int MSRCARD_ERR_CONNECT_FAILED     = MSRCARD_ERR_BASE - 1;
	public static final int MSRCARD_ERR_CMD_TIMEOUT        = MSRCARD_ERR_BASE - 2; 
	public static final int MSRCARD_ERR_SWIPE_ERR          = MSRCARD_ERR_BASE - 3;
	public static final int MSRCARD_ERR_INVALID_TRACK_DATA = MSRCARD_ERR_BASE - 4;
	public static final int MSRCARD_ERR_USER_CANCEL        = MSRCARD_ERR_BASE - 5;
	public static final int MSRCARD_ERR_SWIPE_TIMEOUT      = MSRCARD_ERR_BASE - 6;
	
	
	/***********************MSRCardRead State code defined *********************************************************/
	public static final int MAGCARD_STATE_CLOSED = 0;   //device close
	public static final int MAGCARD_STATE_OPEN = 1;     //device open
	
	
	
	public static final byte PSAM_SUPPORT_SLOT_MIN = 1;

	public static final byte PSAMCARD_SLOT1 = 1;
	public static final byte PSAMCARD_SLOT2 = 2;

	public static final byte PSAM_SUPPORT_SLOT_MAX = 2;


	public static final byte PSAM_SUPPORT_VCC_MIN = 1;
	public static final byte PSAM_VCC_5V = 1;
	public static final byte PSAM_VCC_3V = 2;
	public static final byte PSAM_VCC_1V8 = 3;
	public static final byte PSAM_SUPPORT_VCC_MAX = 1;

	/* Error code defined */
	public static final int PSAM_ERR_BASE = PosDevice.PSAM_ERR_BASE;
	public static final int PSAM_ERR_SUCCESS             = 0;
	public static final int PSAM_ERR_CONNECT_FAILED       = PSAM_ERR_BASE - 1;
	public static final int PSAM_ERR_CMD_TIMEOUT          = PSAM_ERR_BASE - 2;
	public static final int PSAM_ERR_VCCERR               = PSAM_ERR_BASE - 3;
	public static final int PSAM_ERR_SLOTERR              = PSAM_ERR_BASE - 4;
	public static final int PSAM_ERR_APDU                 = PSAM_ERR_BASE - 5;
	public static final int PSAM_ERR_PARERR               = PSAM_ERR_BASE - 6;
	public static final int PSAM_ERR_SEARCH_CARD_TIMEOUT  = PSAM_ERR_BASE - 7;
	public static final int PSAM_ERR_SEARC_CANCEL         = PSAM_ERR_BASE - 8;

	public static final int PSAM_STATE_CLOSED = 0;
	public static final int PSAM_STATE_OPEN=1;
	public static final int PSAM_STATE_READY = 2;
	
	
	/***********************Seacher Card State  *********************************************************/
    public final static byte CARD_NO = 0x00;   //not detect the card
   
    public static final	byte NO_SWIPE_INSERT = 0x00; // 
    public static final byte CARD_SWIPED = 0x01;   //magnetic card
    public static final byte CARD_INSERTED = 0x02;//smart card
    public static final byte CARD_TOUCHED = 0x04;  //contactless smart card
    public static final	byte E_ERR_SWIPE  = 0x12;//  
    public static final byte CARD_ALL = CARD_SWIPED | CARD_INSERTED | CARD_TOUCHED;//check all type card
    
    
    //card read listener result code
    public static final int CARDREADLIS_ERR_TIMEOUT = -1;
    public static final int CARDREADLIS_ERR_ICDEVICE_EXCEPTION  = -2;
    public static final int CARDREADLIS_ERR_MSRDEVICE_EXCEPTION  = -3;
    public static final int CARDREADLIS_ERR_PICCDEVICE_EXCEPTION  = -4;
    public static final int CARDREADLIS_ERR_POWERONFAIL = -5;
    
    /**
	 * The type of this card is unknown
	 */
	public static final byte TYPE_UNKOWN = -1;
	/**
	 * An ISO 14443-3A card 
	 */
	public static final byte NFCCARD_TYPE_A = 0;
	/**
	 * An ISO 14443-3B card
	 */
	public static final byte NFCCARD_TYPE_B = 1;
	/**
	 * FeliCa, 212kbits/s
	 */
	public static final byte NFCCARD_TYPE_C1 = 2;
	
	/**
	 * FeliCa, 424kbits/s
	 */
	public static final byte NFCCARD_TYPE_C2 = 3;
	
	/**
	 * A mifare card 50
	 */
	public static final byte NFCCARD_TYPE_M50 = 4;
	
	/**
	 * A mifare card 70
	 */
	public static final byte NFCCARD_TYPE_M70 = 5;
	
}


