package com.justtide.service.dev.aidl.card;

import com.justtide.service.dev.aidl.card.RFCCardInfo;   
import com.justtide.service.dev.aidl.card.ResponseApduData;
import com.justtide.service.dev.aidl.card.CommandApduData;
import com.justtide.service.dev.aidl.card.RFCCardReaderListener;


interface RFCCardReaderProvider{
	 int open(byte slot);//open device
	 
	 int openDefault();//default parameter open device
	 
	 int close();//close device
	 
	 int getSate();//get device status
	 
	 int startSearch(byte pollMode, byte cardType, int timeoutMs);//start search card 
	 
	 void stopSearch();// stop search card
	 
	 int removeCard();//remove card
	 
	 void detect(RFCCardReaderListener rfcCardReaderListener);//detect the card
	 
	 ResponseApduData transmit(in CommandApduData commandApduData);//send APDU command
	 
	 int mAuthority(byte pwType,byte blkNo,in byte[] pw);
	
	 byte[] mReadBlock(byte blkNo);

	 int mWriteBlock(byte blkNo,in byte[] blkValue);
	 
	 int mSetValue(byte blkNo, int value);
	 
	 int mReadValue(byte blkNo,out int[] outValue);
	 
	 int mIncreaseValue(byte blkNo, int value);
	 
	 int mDecreaseValue(byte blkNo, int value);
	 
	 //int mValueSaveOpRet(byte blkNo);
	 
	 
	
}