package com.justtide.service.dev.aidl.card;

import android.os.Parcel;
import android.os.Parcelable;
public class SmartCardInfo implements Parcelable{

	/*******the card state*******/
	/**
	 * The card is out of slot. 
	 */
	public static final int IS_ABSENT = 0;
	
	/**
	 * The card is in the slot.
	 */
	public static final int IS_PRESENT = 1;
	
	/**
	 * The card has been reset.
	 */
	public static final int IS_ENABLED = 2;
	
	/**
	 * The card is not reset.
	 */
	public static final int IS_DISABLED = 3;
	
	

	/**
	 * ATR
	 */
	private String atr;
	
	/**
	 * 卡片状态
	 */
	private int state;
	
	/**
	 * 电压模式
	 */
	private byte vccMode;
	
	/**
	 * 卡片操作模式
	 */
	private byte operatorMode;
	
 
	public String getAtr() {
		return atr;
	}

	public void setAtr(String atr) {
		this.atr = atr;
	}

	public int getState() {
		return state;
	}

	public void setState(int state) {
		this.state = state;
	}

	public byte getVccMode() {
		return vccMode;
	}

	public void setVccMode(byte vccMode) {
		this.vccMode = vccMode;
	}

	public byte getOperatorMode() {
		return operatorMode;
	}

	public void setOperatorMode(byte operatorMode) {
		this.operatorMode = operatorMode;
	}
	
	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(atr);
		dest.writeInt(state); 
		dest.writeByte(vccMode); 
		dest.writeByte(operatorMode); 
	}
	
	public static final Parcelable.Creator<SmartCardInfo> CREATOR = new Parcelable.Creator<SmartCardInfo>() {

		@Override
		public SmartCardInfo createFromParcel(Parcel source) {
			SmartCardInfo info = new SmartCardInfo();
			info.setAtr(source.readString()); 
			info.setState(source.readInt());
			info.setVccMode(source.readByte());
			info.setOperatorMode(source.readByte());
			return info;
		}

		@Override
		public SmartCardInfo[] newArray(int size) {
			// TODO Auto-generated method stub
			return new SmartCardInfo[size];
		}
	
	};
	
}
