package com.justtide.service.dev.aidl.emv;

 
public class EmvConstant {
	 

	/*********************** Error code defined******************************************/
	public static final int EMV_RET_SUCCESS				 = 0;       //成功  
	public static final int EMV_RET_RSPERR				 = -1;      //返回码错误
	public static final int EMV_RET_APPBLOCK			 = -2;      //应用已锁
	public static final int EMV_RET_NOAPP				 = -3;      //卡片里没有EMV应用
	public static final int EMV_RET_USERCANCEL		     = -4;      //用户取消当前操作或交易
	public static final int EMV_RET_TIMEOUT				 = -5;      //用户操作超时
	public static final int EMV_RET_DATAERR				 = -6;      //卡片数据错误
	public static final int EMV_RET_NOTACCEPT			 = -7;      //交易不接受
	public static final int EMV_RET_DENIAL				 = -8;      //交易被拒绝
	public static final int EMV_RET_KEYEXP				 = -9;      //密钥过期
	public static final int EMV_RET_NOPINPAD			 = -10;     //没有密码键盘或键盘不可用
	public static final int EMV_RET_NOPIN				 = -11;     //没有密码或用户忽略了密码输入
	public static final int EMV_RET_CAPKCHECKSUMERR	     = -12;     //认证中心密钥校验和错误
	public static final int EMV_RET_NOTFOUND			 = -13;     //没有找到指定的数据或元素
	public static final int EMV_RET_NODATA				 = -14;     //指定的数据元素没有数据
	public static final int EMV_RET_OVERFLOW			 = -15;     //内存溢出
	public static final int EMV_RET_NOTRANSLOG		     = -16;     //无交易日志
	public static final int EMV_RET_NORECORD			 = -17;     //无记录
	public static final int EMV_RET_NOLOGITEM			 = -18;     //目志项目错误
	public static final int EMV_RET_ICCRESETERR		     = -19;     //IC卡复位失败
	public static final int EMV_RET_ICCCMDERR			 = -20;     //IC命令失败
	public static final int EMV_RET_ICCBLOCK			 = -21;     //IC卡锁卡 
	public static final int EMV_RET_ICCNORECORD		     = -22;     //IC卡无记录
	public static final int EMV_RET_GENAC1_6985		     = -23;     //GEN AC命令返回6985
	public static final int EMV_RET_DATAEXIST            = -24;
	public static final int EMV_RET_FILEERR              = -25;
	public static final int EMV_RET_PINBLOCK             = -26;
	public static final int EMV_RET_TRYOTHINTERFACE 	 = -27;     //无效输入模式，请使用其它界面
	public static final int EMV_RET_TERMINATE 			 = -28;     //终止处理
	public static final int EMV_RET_INEXCEPFILE 		 = -29;     //属于黑名单卡片
	public static final int EMV_RET_OFFLINEAUTHERR 		 = -30;     //脱机认证失败
	public static final int EMV_RET_SELAIDRSPERR 		 = -31;     //单个AID选择失败之后，须提示使用其它界面 
	public static final int EMV_RET_EXPDATE				 = -32;     //超过有效期
	public static final int EMV_RET_BLACKCARD 		     = -33;     //黑名单卡
	public static final int EMV_RET_INVALIDCARD 		 = -34;     //卡片账号数据错误
	
	
	public static final int EMV_RET_FAIL 		 = -100;     //Emv 返回失败码


	
	
	public static final int  REFER_APPROVE 	= 0x01;     //参考返回码(选择批准)
	public static final int  REFER_DENIAL 	= 0x02;    //参考返回码(选择拒绝)
	public static final int  ONLINE_APPROVE = 0x00;    //联机返回码(联机批准)     
	public static final int  ONLINE_FAILED 	= 0x01;     //联机返回码(联机失败) 
	public static final int  ONLINE_REFER   = 0x02;    //联机返回码(联机参考)
	public static final int  ONLINE_DENIAL  = 0x03;    //联机返回码(联机拒绝)
	public static final int  ONLINE_ABORT   = 0x04;    //兼容PBOC(交易终止)
	
	/********************************EMV FLOW 定义***************************************/
	public static enum FLOW {
		/**
		 * 全流程 
		 * Complete flow
		 */
		COMPLETE,
		/**
		 * 简化流程
		 * simple flow
		 */
		SIMPLE,
		/**
		 * 非接流程
		 * contact less flow
		 */
		QPBOC
	}
	
	
	public static enum EmvTransResult  {
		/**
		 * 联机批准
		 * Online approval
		 */
		ONLINE_APPROVED,
		/**
		 * 联机拒绝
		 * Online refuse
		 */
		ONLINE_DENIED,
		/**
		 * 脱机批准
		 * Offline approval
		 */
		OFFLINE_APPROVED,
		/**
		 * 脱机拒绝
		 * offline refuse
		 */
		OFFLINE_DENIED,
		/**
		 * Host approval,but card refuse
		 * 主机批准，卡片拒绝
		 */
		ONLINE_CARD_DENIED,
		/**
		 * 异常
		 * exception
		 */
		ABORT_TERMINATED,
		/**
		 * 申请联机
		 * Apply online
		 */
		ARQC,
		/**
		 * 简化流程结束
		 * simple flow end
		 */
		SIMPLE_FLOW_END
	
	}
}
