package com.justtide.service.dev.aidl.emv;

import com.justtide.service.dev.aidl.emv.EmvTermParam;
import com.justtide.service.dev.aidl.emv.EmvAidParam;
import com.justtide.service.dev.aidl.emv.EmvCapkParam;
import com.justtide.service.dev.aidl.emv.EmvTransListener;
import com.justtide.service.dev.aidl.emv.EmvTransData;
import com.justtide.service.dev.aidl.emv.EmvChannel;

interface EmvProvider{
	void setTermParam(in EmvTermParam emvTermParam);//Set terminal parameter
	EmvTermParam getTermParam(); //Get terminal parameter
	
	void setAidParam(in EmvAidParam emvAidParam);//Set AID parameter
	int  setAidParamFromFile62(in byte[] field62);//Set AID parameter 
	List<EmvAidParam> getAidParam();//Get AID parameter
	void clearAidParam();//Clear AID parameter
	
	void setCapkParam(in EmvCapkParam emvCapkParam);//Set CAPK parameter
	int setCapkParamFromFile62(in byte[] field62);//Set CAPK parameter 
	List<EmvCapkParam> getCapkParam();//Get CAPK parameter
	void clearCapkParam();//Clear CAPK parameter
	
	int setTlv(int tag, in byte[] value);//Set TLV value
	byte[] getTlv(int tag);//Get TLV value
		
	int process(in EmvTransData emvTransData, in EmvTransListener emvTransListener);//EMV process
	List<String> readLogRecord(in EmvChannel emvChannel, in int logType);//read record
	long getEcBalance(in EmvChannel emvChannel);//Get EC balance
	
}