package com.justtide.service.dev.aidl.pinpad;

import android.os.Parcel;
import android.os.Parcelable;

public class KeyInfo implements Parcelable{

	private int keyType; //key type
	private int tdesType;  //encryption type
	private int verifyType; //verify type
	private int mKeyIndex; //master key index, when keyType is the master key,the parameter is invalid
	private int wKeyIndex; //work key index,when keyType is the master key,the parameter mean master key index
	private byte[] keyData;//Key data
	private int keyDataLen;	//key length
	private byte[] kcvValue;//check value,if no check value is null
	private int kcvValueLen;//check value length,if no check value is 0
	
	
	public int getKeyType() {
		return keyType;
	}

	public void setKeyType(int keyType) {
		this.keyType = keyType;
	}
	
	public int getTdesType() {
		return tdesType;
	}

	public void setTdesType(int tdesType) {
		this.tdesType = tdesType;
	}

	public int getVerifyType() {
		return verifyType;
	}

	public void setVerifyType(int verifyType) {
		this.verifyType = verifyType;
	}

	public int getmKeyIndex() {
		return mKeyIndex;
	}

	public void setmKeyIndex(int mKeyIndex) {
		this.mKeyIndex = mKeyIndex;
	}

	public int getwKeyIndex() {
		return wKeyIndex;
	}

	public void setwKeyIndex(int wKeyIndex) {
		this.wKeyIndex = wKeyIndex;
	}

	public byte[] getKeyData() {
		return keyData;
	}

	public void setKeyData(byte[] keyData) {
		this.keyData = keyData;
	}

	public int getKeyDataLen() {
		return keyDataLen;
	}

	public void setKeyDataLen(int keyDataLen) {
		this.keyDataLen = keyDataLen;
	}

	public byte[] getKcvValue() {
		return kcvValue;
	}

	public void setKcvValue(byte[] kcvValue) {
		this.kcvValue = kcvValue;
	}

	public int getKcvValueLen() {
		return kcvValueLen;
	}

	public void setKcvValueLen(int kcvValueLen) {
		this.kcvValueLen = kcvValueLen;
	}

	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeInt(keyType);
		dest.writeInt(tdesType);
		dest.writeInt(verifyType);
		dest.writeInt(mKeyIndex);
		dest.writeInt(wKeyIndex);
		if (keyData!=null) {
			keyDataLen = keyData.length;
			dest.writeInt(keyDataLen);
			dest.writeByteArray(keyData);
		}else{
			dest.writeInt(0);
		}
		if (kcvValue!=null) {
			kcvValueLen = kcvValue.length;
			dest.writeInt(kcvValueLen);
			dest.writeByteArray(kcvValue);
		}else {
			dest.writeInt(0);
		}
	}
	
	public static final Parcelable.Creator<KeyInfo> CREATOR = new Parcelable.Creator<KeyInfo>() {

		@Override
		public KeyInfo createFromParcel(Parcel source) {
			
			KeyInfo info = new KeyInfo();
			info.setKeyType(source.readInt());
			info.setTdesType(source.readInt());
			info.setVerifyType(source.readInt());		 
			info.setmKeyIndex(source.readInt());
			info.setwKeyIndex(source.readInt());
			
			int keyDataLen = source.readInt();
			info.setKeyDataLen(keyDataLen);
			if (keyDataLen != 0) {
				byte[] keyData = new byte[keyDataLen];
				source.readByteArray(keyData);
				info.setKeyData(keyData);
			}
			
			int kcvValueLen = source.readInt();
			info.setKcvValueLen(kcvValueLen);
			if (kcvValueLen != 0) {
				byte[] kcvValue = new byte[kcvValueLen];
				source.readByteArray(kcvValue);
				info.setKcvValue(kcvValue);
			}
			
			return info;
		}

		@Override
		public KeyInfo[] newArray(int size) {
			// TODO Auto-generated method stub
			return new KeyInfo[size];
		}
	
	};
	
}
