package com.justtide.service.dev.aidl.pinpad;

public class PinpadConstant {

	/***************************** Error code defined******************************************/
	
	public static final int PINPAD_ERR_BASE                  = -6000;
	public static final int PINPAD_ERR_SUCCESS               = 0;
	public static final int PINPAD_ERR_CONNECT_FAILED        = PINPAD_ERR_BASE - 1;
	public static final int PINPAD_ERR_CMD_TIMEOUT           = PINPAD_ERR_BASE - 2;
	public static final int PINPAD_ERR_GETPIN_TIMEOUT        = PINPAD_ERR_BASE - 3;
	public static final int PINPAD_ERR_SART_INPUT_PAD_FAILED = PINPAD_ERR_BASE - 4;
	
	public static final int PINPAD_RET_OK             = 0x00;	//  PED OK
	public static final int PINPAD_RET_BASE_NO		  = -2000;
	public static final int PINPAD_RET_LOCKED         = (PINPAD_RET_BASE_NO -  1);	//  PINPAD Locked
	public static final int PINPAD_RET_ERROR          = (PINPAD_RET_BASE_NO -  2);	//  The others error
	public static final int PINPAD_RET_COMMERR        = (PINPAD_RET_BASE_NO -  3);	//  Communicate with PINPAD failed
	public static final int PINPAD_RET_NEEDAUTH       = (PINPAD_RET_BASE_NO -  4);	//  Need auth before use sensitive service or expired
	public static final int PINPAD_RET_AUTHERR        = (PINPAD_RET_BASE_NO -  5);	//  PINPAD auth failed
	public static final int PINPAD_RET_WEAK_KEY	      = (PINPAD_RET_BASE_NO -  6);	//  weak length key
	public static final int PINPAD_RET_COLLISION_KEY  = (PINPAD_RET_BASE_NO -  7);	//  collision key
	public static final int PINPAD_RET_KEYINDEXERR    = (PINPAD_RET_BASE_NO -  8);	//  The index of key incorrect
	public static final int PINPAD_RET_NOKEY          = (PINPAD_RET_BASE_NO -  9);	//  No designated key in PINPAD
	public static final int PINPAD_RET_KEYFULL        = (PINPAD_RET_BASE_NO - 10);	//  Key space is full
	public static final int PINPAD_RET_OTHERAPPKEY    = (PINPAD_RET_BASE_NO - 11);	//  The designated key is not belong to this APP
	public static final int PINPAD_RET_KEYLENERR      = (PINPAD_RET_BASE_NO - 12);	//  The key length error
	public static final int PINPAD_RET_NOPIN          = (PINPAD_RET_BASE_NO - 13);	//  Card holder press ENTER directly when enter PIN(no PIN)
	public static final int PINPAD_RET_CANCEL         = (PINPAD_RET_BASE_NO - 14);	//  Card holder press CANCEL to quit enter PIN
	public static final int PINPAD_RET_TIMEOUT        = (PINPAD_RET_BASE_NO - 15);	//  Timeout
	public static final int PINPAD_RET_NEEDWAIT       = (PINPAD_RET_BASE_NO - 16);	//  Two frequent between 2 sensitive API
	public static final int PINPAD_RET_KEYOVERFLOW    = (PINPAD_RET_BASE_NO - 17);	//  DUKPT KEY overflow
	public static final int PINPAD_RET_NOCARD         = (PINPAD_RET_BASE_NO - 18);	//  No ICC
	public static final int PINPAD_RET_ICCNOTPWRUP    = (PINPAD_RET_BASE_NO - 19);	//  ICC no power up
	public static final int PINPAD_RET_PARITYERR      = (PINPAD_RET_BASE_NO - 20);	//  The parity incorrect
	public static final int PINPAD_RET_UNSUPPORTED	  = (PINPAD_RET_BASE_NO - 255);	//  can not support

	
	/***********************常量定义*************************************************************/
	/*TDES类型*/
	public static final int TDES_TYPE_DECRYPT            = 0x00000000;	// TDES解密
	public static final int TDES_TYPE_ENCRYPT            = 0x00000001;	// TDES加密
	public static final int TDES_TYPE_NONE               = 0x00000002;	// 不做加解密操作
	
	/*TDES模式*/
	public static final int TDES_MODE_ECB			= 0x00000000;	// TDES MODE ECB
	public static final int TDES_MODE_CBC			= 0x00000100;	// TDES MODE CBC
	public static final int TDES_MODE_CFB			= 0x00000200;	// TDES MODE CFB
	public static final int TDES_MODE_OFB			= 0x00000300;	// TDES MODE OFB
	
	/* 主密钥、工作密钥导入校验类型 */
	public static final int KEY_VERIFY_TYPE_NONE	= 0x00000000;	// 无
	public static final int KEY_VERIFY_TYPE_KCV	    = 0x01000000;	// KCV
	public static final int KEY_VERIFY_TYPE_CMAC	= 0x02000000;	// CMAC
	public static final int KEY_VERIFY_TYPE_MASK	= 0xff000000;	// 掩码
	
	/*Mac 算法类型*/
	public static final int MAC_MODE_CBC				= 0x00;	//  MAC method 1, TDES-TDES...TDES   加密---异或 ---加密 。。。。最后加密
	public static final int MAC_MODE_ECB				= 0x01;	//  MAC method 2, XOR...XOR...TDES
	public static final int MAC_MODE_EMV			= 0x02;	//  MAC for EMV EMV, DES-DES...TDES
	public static final int MAC_MODE_CUP			= 0x03;	//  MAC for CUP, XOR-XOR...TDES(left)-XOR-TDES...
	public static final int MAC_MODE_DUKPT			= 0x04;	//  MAC for DUKPT,Expand, XOR-XOR...TDES(left)-XOR-TDES...
	
	/*PIN 算法类型*/ 
	public static final int PIN_BLOCK_FORMAT_CUP	= 0x00;	//  PIN BLOCK FORMAT 0
	public static final int PIN_BLOCK_FORMAT_1		= 0x01;	//  PIN BLOCK FORMAT 1
	public static final int PIN_BLOCK_FORMAT_2		= 0x02;	//  PIN BLOCK FORMAT 2
	public static final int PIN_BLOCK_FORMAT_3		= 0x03;	//  PIN BLOCK FORMAT 3
	public static final int PIN_BLOCK_FORMAT_4		= 0x04;	//  PIN BLOCK FORMAT 4
	public static final int PIN_BLOCK_FORMAT_EPS	= 0x0A;	//  PIN BLOCK FORMAT EPS
	
	/***********************密钥类型定义******************************************/
	/**
	 * 密钥类型:主密钥
	 * key type:master key
	 */
	public static final int KEYTYPE_MKEY     = 0x01;
	/**
	 * 密钥类型:PIN密钥
	 * key type:PIN key
	 */
	public static final int KEYTYPE_PINKEY   = 0x02;
	/**
	 * 密钥类型:MAC密钥
	 * key type:MAC key
	 */
	public static final int KEYTYPE_MACKEY   = 0x03;
	/**
	 * 密钥类型:DES密钥
	 * key type:des key
	 */
	public static final int KEYTYPE_DESKEY   = 0x04; 
}
