package com.justtide.service.dev.aidl.pinpad;

import com.justtide.service.dev.aidl.pinpad.KeyInfo;
import com.justtide.service.dev.aidl.pinpad.RSAInfo;
import com.justtide.service.dev.aidl.pinpad.PinPadListener;
interface PinpadProvider{
	 int setInputPinTimeout(int timeoutMS);//set pinpad timeout
	 
	 int importKey(in KeyInfo keyInfo); //import key
	 
	 //import master key
	 int importMasterKey(int tdesType,int verifyType, int mastKeyId, int destKeyId,in byte[] keyData); 
	 //import PIN key
	 int importPinKey(int tdesType,int verifyType, int mastKeyId, int destKeyId,in byte[] keyData);
	 //import MAC key
	 int importMacKey(int tdesType,int verifyType, int mastKeyId, int destKeyId,in byte[] keyData); 
	 //import Des key
	 int importDesKey(int tdesType,int verifyType, int mastKeyId, int destKeyId,in byte[] keyData); 
	 //import master key by the key distribution POS
	 int loadMkeyByComm(int mastKeyId); 
	 
	 //get pinblock
	 int calcPinblock(int keyIndex, int pinMode,in byte[] cardNo,in byte[] expectPinLenList,in PinPadListener pinPadListener);//计算Pinblock
	 
	 //get MAC
	 byte[] calcMac(int keyIndex, int macMode,in byte[] inMacData);//MAC计算
	 
	 //encryption
	 byte[] calcDes(int keyIndex, int desMode,in byte[] inData);//加解密计算
	 
	 //脱机密文PIN
	 byte[] iccOfflineCipherPin(in byte[] inExpPinLenList,in byte[] apdu,in RSAInfo rsaInfo);
	 
	 //脱机明文PIN
	 byte[] iccOfflinePlainPin(in byte[] inExpPinLenList,in byte[] apdu);
	 
	 //get rand
	 byte[] getRandom(int randomLen);//获取随机数
	
}