package com.justtide.service.dev.aidl.pinpad;
 
import android.os.Parcel;
import android.os.Parcelable;

public class RSAInfo implements Parcelable{

 
	
	private byte[] random ; //max length 8 byte
	private int randomLen; ;
	private byte[] rsaPubKeyPoint; //max length 4 byte
	private int pointLen ;
	private byte[] rsaPubKeyMod; //max length 256 byte
	private int modLen;
	
	
	public byte[] getRandom() {
		return random;
	}

	public void setRandom(byte[] random) {
		this.random = random;
	}
	
	public int getRandomLen() {
		return randomLen;
	}

	public void setRandomLen(int randomLen) {
		this.randomLen = randomLen;
	}
	
	public byte[] getRsaPubKeyPoint() {
		return rsaPubKeyPoint;
	}

	public void setRsaPubKeyPoint(byte[] rsaPubKeyPoint) {
		this.rsaPubKeyPoint = rsaPubKeyPoint;
	}

	public int getPointLen() {
		return pointLen;
	}

	public void setPointLen(int pointLen) {
		this.pointLen = pointLen;
	}

	public byte[] getRsaPubKeyMod() {
		return rsaPubKeyMod;
	}

	public void setRsaPubKeyMod(byte[] rsaPubKeyMod) {
		this.rsaPubKeyMod = rsaPubKeyMod;
	}
	
	public int getModLen() {
		return modLen;
	}

	public void setModLen(int modLen) {
		this.modLen = modLen;
	}

	 

	@Override
	public int describeContents() {
		return 0;
	}

	@Override
	public void writeToParcel(Parcel dest, int flags) {
		if (random !=null) {
			randomLen = random.length;
			dest.writeInt(randomLen);
			dest.writeByteArray(random);
		}else {
			dest.writeInt(0);
		}
		
		if (rsaPubKeyPoint !=null) {
			pointLen = rsaPubKeyPoint.length;
			dest.writeInt(pointLen);
			dest.writeByteArray(rsaPubKeyPoint);
		}else {
			dest.writeInt(0);
		}
		
		if (rsaPubKeyMod !=null) {
			modLen = rsaPubKeyMod.length;
			dest.writeInt(modLen);
			dest.writeByteArray(rsaPubKeyMod);
		}else {
			dest.writeInt(0);
		}
		
		 
	}
	
	public static final Parcelable.Creator<RSAInfo> CREATOR = new Parcelable.Creator<RSAInfo>() {

		@Override
		public RSAInfo createFromParcel(Parcel source) {
			
			RSAInfo info = new RSAInfo();
 
			int randomLen = source.readInt();
			info.setRandomLen(randomLen);
			if (randomLen != 0) {
				byte[] random = new byte[randomLen];
				source.readByteArray(random);
				info.setRandom(random);
			}
			
			int pointLen = source.readInt();
			info.setPointLen(pointLen);
			if (pointLen != 0) {
				byte[] rsaPubKeyPoint = new byte[pointLen];
				source.readByteArray(rsaPubKeyPoint);
				info.setRsaPubKeyPoint(rsaPubKeyPoint);
			}
			
			int modLen = source.readInt();
			info.setModLen(modLen);
			if (modLen != 0) {
				byte[] rsaPubKeyMod = new byte[modLen];
				source.readByteArray(rsaPubKeyMod);
				info.setRsaPubKeyMod(rsaPubKeyMod);
			}
			
			return info;
		}

		@Override
		public RSAInfo[] newArray(int size) {
			// TODO Auto-generated method stub
			return new RSAInfo[size];
		}
	
	};
	
}
